# UnRemove

## Restore destroyed pieces and place overlapping pieces with ease!

How frustrating is it when you keep breaking items accidentally? How about when you tried to fit overlapping pieces together only to be blocked by the first piece? 

With UnRemove you can restore deleted pieces without rebuilding. 

UnRemove also makes it easy to position overlapping pieces - place a piece, delete it, place the overlapping piece, then restore the first - easy.

UnRemove keeps track of recently removed items, will undo your 'delete', and restore the piece with a single key press.


## New

- 0.1.4: Updated for Valheim patch 0.216.5
- 0.1.3: Updated for Mistlands

## Configuration

### General

- **UndoKey**: Key to press to undo the most recently removed item. Default is U
- **UndoSize**: The number of removed items to keep in the undo buffer. Can be set from 1 to 20. Default is 5

### Utility

- **LogLevel**: Controls the level of information in the log

### In-game reconfiguration

You can use Configuration Manager (or similar) mod to change the configuration without exiting the game, and force a configuration update from the chat window (press Enter) then type:

    /unremove config 

You can also modify the undo buffer size directly from the chat window using this syntax:

    /unremove undosize=10

## Notes

- You need to have sufficient resources in your inventory to restore. You cannot 'destroy' and 'undo' as a means to generate resources. The amount needed to restore a piece is the same as building it to begin with. Usually this won't be an issue, since all the items you need are dropped by the 'destroy'.
- UnRemove cannot pull resources automatically from containers via Craft From Containers. Resources need to be in your inventory.
- UnRemove will only restore one single piece at a time. It will not 'cascade' restore connected pieces. For instance, it will not restore your tower if the piece you removed caused the tower to collapse, or the item hook that was attached to your destroyed wall piece.
- If you resize the undo buffer in-game, you will lose the current 'restore-able' items.
- Your comments and feedback are always welcome. Please feel free to post or send a note on NexusMods.

### Compatibility issues & defects

- If you find a compatibility issue you can post it on NexusMods. Be sure to include the mod name and version you think may be incompatible.
- If you have a bug please report it on NexusMods. If you do post a bug report, please make sure to include the following:
    - Your version of this mod
    - What you were doing, or attempting to do when it happened
    - If it's repeatable - i.e., can you duplicate it?
    - The exact behavior you observed (or didn't observe)
    - If possible, post a capture of the log file with errors (errors always begin with this mod's name) on Discord


You can find all Neobotics released mods on: 
- Thunderstore: https://tinyurl.com/NeoboticsOnThunderstore 
- Nexus Mods: https://tinyurl.com/NeoboticsOnNexus

Your comments and feedback are always welcome. Post on NexusMods or Discord: https://tinyurl.com/NeoboticsOnDiscord